C**********************************************************************
C                 Copyright 1992-1996, Robert Fraczkiewicz            *
C                           All rights reserved.                      *
C**********************************************************************
C This program is free software; you can redistribute it and/or modify*
C it under the terms of the GNU General Public License as published by*
C the Free Software Foundation; either version 1, or (at your option) *
C any later version.                                                  *
C                                                                     *
C This program is distributed in the hope that it will be useful,     *
C but WITHOUT ANY WARRANTY; without even the implied warranty of      *
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU    *
C General Public License for more details.                            *
C                                                                     *
C You should  have received a copy of the GNU General Public License  *
C along with this program; if not, write to the Free Software         *
C Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
C**********************************************************************
C                                                                     *
C      Generator of XMol animation files by R. Fraczkiewicz, 03/94    *
C                         version 1.0                                 *
C                                                                     *
C**********************************************************************
C                                                                     *
C     dimensions:                                                     *
C     x,dx                                     - natomx3              *
C                                                                     *
C  ANIM reads output of the program DT2                               *
C**********************************************************************

      program anim
      implicit real*8(a-h,o-z)
      parameter(pi=3.14159265358979324,nstep=30)
      character*14 name,cr
      character*80 comment
      character*4 atom(200)
      dimension x(200,3),dx(200,3),xp(200,3),dxp(200,3)
c**********************************************************************
      print *,'Input name of the data file and press <return>.   '
      print *,'The ".xyz",extension will be automatically assumed.   '
      print *,'Length of the name cannot exceed 14 characters.    '
      read(*,'(a14)') name
      l_name=namlen(name)
      print *,'Input multiplication factor                  '
      read(*,*) razy
      print *,'The results of will be stored in the    '
      print *,'output files "name-output_number.xyz". '
      print *,'Press <return> when ready...'
      read(*,'(a1)') cr
      dt=2.0*pi/nstep
      open(unit=7, file=name(1:l_name)//'.xyz', err=2991, status='old')
   10 read(7,*,err=20) noat
      read(7,800) comment
      do k=1,noat
       read(7,900) atom(k),(x(k,l), l=1,3),(dx(k,l),l=1,3)
      enddo
      print *,'Do you want:'
      print *,comment
      print *,'<y/n/q> ?'
   15 read(*,'(a1)') cr
      if(cr.eq.'Y'.or.cr.eq.'y') then 
       call liczba(comment,cr)
       l_cr=namlen(cr)
       open(unit=8,file=name(1:l_name)//'_'//cr(1:l_cr)//
     .'.xyz',status='unknown')
       do i=0,nstep-1
        pom=sin(i*dt)
        pom2=float(i)/float(nstep)
        if(pom2.gt.0.25.and.pom2.lt.0.75) then
         coef=-1.0
        else
         coef=1.0
        endif
        write(8,*) noat
        write(8,800) comment
        do k=1,noat
         do l=1,3
          xpom1=razy*dx(k,l)
          xpom2=xpom1*pom
          xp(k,l)=x(k,l)+xpom2
          dxp(k,l)=coef*xpom1-xpom2
         enddo
         write(8,900) atom(k),(xp(k,l), l=1,3),(dxp(k,l),l=1,3)
        enddo
       enddo
       close(unit=8)
      else 
       if (cr.eq.'Q'.or.cr.eq.'q') goto 20
      endif
      go to 10
   20 close(unit=7)
      stop 1
  800 format(a80)
  900 format(3x,a4,3(1x,f9.5),3(1x,f9.5))
c  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2991 print *
      print *,'Input operation unsuccesful. Can''t find file '
     .//name(1:l_name)//'.xyz'
      stop 2
 9990 print *
      print *,'Input operation unsuccesful. Check the name and format'
      print *,'of the data file. Don''t write filename extension.'
      stop 3
c  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      end

      integer function namlen(stri)
      implicit real*8(a-h,o-z)
      character*14 stri
      do i=1,len(stri)
       if(stri(i:i).eq.' ') goto 2
      enddo
    2 namlen=i-1
      return
      end

      subroutine liczba(stri,cr)
      implicit real*8(a-h,o-z)
      character*80 stri
      character*14 cr
      i=1
      j=1
   10 if(stri(i:i).ne.' ') goto 20
      i=i+1
      j=i
      goto 10
   20 j=j+1
      if(stri(j:j).eq.' ') goto 30
      goto 20
   30 cr=stri(i:j-1)
      return
      end
